#define INTUI_V36_NAMES_ONLY

#ifdef AMITCP
	#define PROTO_TIMER_H
	#define CLIB_SOCKET_INLINES_H
#endif

#include <proto/dos.h>
#include <proto/intuition.h>
#include <proto/gadtools.h>
#include <proto/timer.h>
#include <proto/commodities.h>
#include <proto/exec.h>
#include <proto/timer.h>
#include <proto/icon.h>
#include <exec/types.h>
#include <exec/ports.h>
#include <exec/libraries.h>
#include <exec/execbase.h>
#include <exec/memory.h>
#include <exec/ports.h>
#include <libraries/gadtools.h>
#include <libraries/commodities.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <intuition/imageclass.h>
#include <intuition/gadgetclass.h>
#include <intuition/sghooks.h>
#include <graphics/displayinfo.h>
#include <graphics/gfxbase.h>
#include <workbench/startup.h>
#include <devices/timer.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <fcntl.h>
/*#include <time.h> */

#ifdef AMITCP
	#define SOCKLIBNAME "bsdsocket.library"
	#define SOCKLIBVERSION (2L)
	#include <bsdsocket.h>
	#include <sys/ioctl.h>
	#include <sys/time.h>
	#include <signal.h>
	#define selectwait WaitSelect
	#undef select
	#define select(a, b, c, d, e) selectwait(a, b, c, d, e, NULL)
	#define s_close CloseSocket
	#define s_ioctl IoctlSocket
	#undef inet_ntoa
	#define inet_ntoa Inet_NtoA
	#undef inet_netof
	#define inet_netof Inet_NetOf
	#undef inet_lnaof
	#define inet_lnaof Inet_LnaOf
	#define accept(a, b, c) accept(a, b, (LONG *)c)
	#define s_release(a) (void *)ReleaseSocket(a, -1)
	#define s_inherit(a) ObtainSocket((LONG)a, AF_INET, SOCK_STREAM, 0)
	#define SocketBase SockBase
	extern int errno;
#else
	#include <ss/socket.h>
	#define SOCKLIBNAME "inet:libs/socket.library"
	#define SOCKLIBVERSION 4L
#endif

#include "asyncio.h"

#define MAXSOCKS 10

#define GetString( g )      ((( struct StringInfo * )g->SpecialInfo )->Buffer  )
#define GetNumber( g )      ((( struct StringInfo * )g->SpecialInfo )->LongInt )

#define GD_MYGAD_USER                          0
#define GD_MYGAD_PASSWORD                      1
#define GD_MYGAD_DELETE                        2
#define GD_MYGAD_MAILBOX                       3
#define GD_MYGAD_BUTTON                        4
#define GD_MYGAD_HOST                          5
#define GD_MYGAD_TIME                          6
#define GD_MYGAD_CRONCHECK                     7
#define GD_MYGAD_APPEND                        8

#define GDX_MYGAD_USER                         0
#define GDX_MYGAD_PASSWORD                     1
#define GDX_MYGAD_DELETE                       2
#define GDX_MYGAD_MAILBOX                      3
#define GDX_MYGAD_BUTTON                       4
#define GDX_MYGAD_HOST                         5
#define GDX_MYGAD_TIME                         6
#define GDX_MYGAD_CRONCHECK                    7
#define GDX_MYGAD_APPEND                       8

#define Project0_CNT 9

extern struct Screen        *Scr;
extern UBYTE                *PubScreenName;
extern APTR                  VisualInfo;
extern struct Window        *Project0Wnd;
extern struct Gadget        *Project0GList;
extern struct Menu          *Project0Menus;
extern struct IntuiMessage   Project0Msg;
extern struct Gadget        *Project0Gadgets[9];
extern UWORD                 Project0Width;
extern UWORD                 Project0Height;
extern UBYTE                *Project0Wdt;
extern struct TextAttr      *Font, Attr;
extern UWORD                 FontX, FontY;
extern UWORD                 OffX, OffY;
extern struct NewMenu        Project0NewMenu[];
extern UWORD                 Project0GTypes[];
extern struct NewGadget      Project0NGad[];
extern ULONG                 Project0GTags[];

extern int MYGAD_USERClicked( void );
extern int MYGAD_PASSWORDClicked( void );
extern int MYGAD_DELETEClicked( void );
extern int MYGAD_MAILBOXClicked( void );
extern int MYGAD_BUTTONClicked( void );
extern int MYGAD_HOSTClicked( void );
extern int MYGAD_TIMEClicked( void );
extern int MYGAD_CRONCHECKClicked( void );
extern int MYGAD_APPENDClicked( void );
extern int Project0MENU_HIDE( void );
extern int Project0MENU_ABOUT( void );
extern int Project0MENU_QUIT( void );

extern int SetupScreen( void );
extern void CloseDownScreen( void );
extern void Project0Render( void );
extern int HandleProject0IDCMP( void );
extern int Project0CloseWindow( void );
extern int Project0VanillaKey( void );
extern int Project0ChangeWindow( void );
extern int OpenProject0Window( void );
extern void CloseProject0Window( void );

/* My Protos */

extern int main( int, char **);
extern void openup( void );
extern void closedown( void );
extern BOOL parse( int );
extern LONG *ParseParameters(int , char *);
void FreeParameters( LONG * );
extern BOOL makevars( void );
extern void freevars( void );

extern int setupcx( void );
extern void closecx( void );
extern int docx( void );

extern int dopop( void );
extern int senduser( int );
extern int sendquit( int );
extern int sendstat( int );
extern int retrieve ( int , int );
extern int lastblock (char * );
extern char * strip( char * );
extern int delmessage( int , int );
extern int doreq( const char * , const char * );
extern int valcheck( int, char * );
extern int trans( int , char *);
extern void settitle( char * );

extern int setuptime( void );
extern int closetime(void );
extern void timereq( void );

extern __stdargs void DoFmt (char *buf, const char *fmt, ...); /* sprintf() replacement */


/* Variables */

#define EVT_HOTKEY 1L
#define PASSCHAR ''
#define SMALLSTRING 64
#define BIGSTRING 255
#define BUFSIZE 257

extern char *pophost;
extern char *username;
extern char *password;
extern char *passfake;
extern char *mailbox;
extern char *cxname;
extern char *cxdesc;
extern char *hotkey;
extern char *title;
extern char *temp;
extern char *buf;

extern char bum[];

extern BOOL delmail;
extern BOOL checkper;
extern BOOL appfile;
extern BOOL winop;
extern BOOL notify;

extern int timecheck;
extern int port;
extern int winx;
extern int winy;

extern ULONG cxsigflag;
extern ULONG sigmask;
extern ULONG timesigflag;

extern struct MsgPort *amipop_mp;
extern struct MsgPort *timer_mp;
extern struct WBStartup *_WBenchMsg;
extern struct timerequest *timerio;
extern CxObj *broker;
extern struct NewBroker newbroker;
extern struct Library *TimerBase;
extern struct IntuitionBase *IntuitionBase;
extern struct Library *GadToolsBase;

extern UWORD __chip waitPointer[];
